osgShadow::ViewDependentShadowTechnique Class Reference

`#include <ViewDependentShadowTechnique>`

Inheritance diagram for osgShadow::ViewDependentShadowTechnique:

## Classes

struct | ViewData

## Public Member Functions

| ViewDependentShadowTechnique (void)
| ViewDependentShadowTechnique (const ViewDependentShadowTechnique &vdst, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgShadow, ViewDependentShadowTechnique)
virtual void | dirty ()
virtual void | init ()
virtual void | update (osg::NodeVisitor &nv)
virtual void | cull (osgUtil::CullVisitor &cv)
virtual void | cleanSceneGraph ()
virtual void | traverse (osg::NodeVisitor &nv)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osgShadow::ShadowTechnique
| ShadowTechnique ()
| ShadowTechnique (const ShadowTechnique &es, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | setShadowedScene (ShadowedScene *ss)
ShadowedScene * | getShadowedScene ()
const ShadowedScene * | getShadowedScene () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::map< osg::ref_ptr< osg::Identifier >, osg::ref_ptr< ViewData > > | ViewDataMap

## Protected Member Functions

| ~ViewDependentShadowTechnique (void)
virtual ViewDependentShadowTechnique::ViewData * | getViewDependentData (osgUtil::CullVisitor *cv)
virtual void | setViewDependentData (osgUtil::CullVisitor *cv, ViewDependentShadowTechnique::ViewData *data)
Protected Member Functions inherited from osgShadow::ShadowTechnique
osg::Vec3 | computeOrthogonalVector (const osg::Vec3 &direction) const
virtual | ~ShadowTechnique ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ViewDataMap | _viewDataMap
OpenThreads::Mutex | _viewDataMapMutex
Protected Attributes inherited from osgShadow::ShadowTechnique
ShadowedScene * | _shadowedScene
bool | _dirty
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

ViewDependentShadowTechnique is a base class for all View Dependent Shadow techniques. It defines fundamental object structure and methods to manage separate shadow resources for each view of the scene. By view we understand osg::View or SceneView instance and their associated Camera. Typical osg application has one or more such views. View Dependent Shadow techniques manage shadow generation for them.

View Dependent Shadow techniques are used to optimize shadow algorithms for part of the scene seen on the view. If rest of the scene is behind view frustum, there is no sense in computing shadows for it. Since in practice we often use 3d databases extending far beyond current camera frustum View Dependent Shadow approach may produce much better shadows.

The other goal is to provide framework for thread safe rendering of the shadows. It allows to use shadows with different OSG threading models.

Conceptually ViewDependentShadowTechnique is similar to osgSim::OverlayNode. Its a container class for number of ViewData (or ViewData derived) objects doing actual shadow work for each of the scene views.

But ViewDependentShadowTechnique is intended as foundation layer for all derived classes so in some way it extends osgSim::OverlayNode approach a bit.

HOW IT WORKS:

ViewDependendentShadowTechnique is derived from osgShadow::ShadowTechnique and as such overrides virtual methods of osgShadow::ShadowTechnique. But most of the shadow dirty work is done by ViewData objects, ViewDependendentShadowTechnique::cull is the only osgShadow::ShadowTechnique method where ViewDependendentShadowTechnique does something significant:

What ViewDependentShadowTechnique::cull( CullVisitor & cv ) does ? It identifies View. CullVisitor ptr is used as View identificator. In practice we do not check and interpret what are actual Views and SceneViews set up by application. We focus on Camera and CullVisitors as a identificators of views. We can safely do this because each such view will have associated unique CullVisitor used to cull the scene in every frame.

Based on CullVisitor ptr passed to cull method, associated Technique::ViewData object is created (if necessary) and then seleced. Then control is passed to this ViewData object. So, each view has its associated unique ViewData (or derived) object performing dirty work of shadow resources management and shadow generation for the view.

To support creation of classes derived from ViewDependentShadowTechnique it was necessary to provide mechanism to override ViewData and allow for initialization of new derived ViewData objects. Creation and initialization is performed when ViewDependendentShadowTechnique::cull gets called with CullVistor ptr which does not yet have associated ViewData object. When it happens, virtual initViewDependentData method is called to give derived techniques a chance to allocate and iniitalize its specific resources as new ViewData derived instance. In practice initViewDependentData in derived techniques should look the same as in base class so as a convenience it was defined as META_ViewDependentShadowTechnique macro. Derived techniques use this macro to override initViewDependentData method for their usage.

After ViewData derived object is construted and selected, control is passed to this object by call to virtual ViewData::cull method. The rest of work is the done by this object. ViewDependentShadowTechnique::ViewData is intended as a base class so it does nothing. In practice the rest of dirty work will do new ViewData classes implemented in derived techniques.

## Member Typedef Documentation

## ViewDataMap

typedef std::map< osg::ref_ptr< osg::Identifier >, osg::ref_ptr< ViewData > > osgShadow::ViewDependentShadowTechnique::ViewDataMap

protected

Map of view dependent data per view cull visitor (CVs are used as indices) ViewDependentShadowTechnique uses this map to find VieData for each cull vitior

## Constructor & Destructor Documentation

## ViewDependentShadowTechnique() [1/2]

osgShadow::ViewDependentShadowTechnique::ViewDependentShadowTechnique | ( | void |  | ) |

osgShadow::ShadowTechnique equivalent methods for view dependent techniques Classic OSG constructor

Referenced by osgShadow::ViewDependentShadowTechnique::ViewData::init(), META_Object(), setViewDependentData(), and ViewDependentShadowTechnique().

## ViewDependentShadowTechnique() [2/2]

osgShadow::ViewDependentShadowTechnique::ViewDependentShadowTechnique | ( | const ViewDependentShadowTechnique & | vdst,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Classic OSG cloning constructor

References osg::CopyOp::SHALLOW_COPY, and ViewDependentShadowTechnique().

## ~ViewDependentShadowTechnique()

osgShadow::ViewDependentShadowTechnique::~ViewDependentShadowTechnique | ( | void |  | ) |

protected

Classic protected OSG destructor

## Member Function Documentation

## cleanSceneGraph()

virtual void osgShadow::ViewDependentShadowTechnique::cleanSceneGraph | ( |  | ) |

virtual

Clean scene graph from any shadow technique specific nodes, state and drawables.

Reimplemented from osgShadow::ShadowTechnique.

## cull()

virtual void osgShadow::ViewDependentShadowTechnique::cull | ( | osgUtil::CullVisitor & | cv | ) |

virtual

Run the cull traversal of the ShadowedScene and set up the rendering for this ShadowTechnique.

Reimplemented from osgShadow::ShadowTechnique.

## dirty()

virtual void osgShadow::ViewDependentShadowTechnique::dirty | ( |  | ) |

virtual

Dirty view data bits and force update of view data resources

Reimplemented from osgShadow::ShadowTechnique.

Referenced by osgShadow::StandardShadowMap::setBaseTextureUnit(), osgShadow::StandardShadowMap::setShadowTextureUnit(), and osgShadow::StandardShadowMap::setTextureSize().

## getViewDependentData()

virtual ViewDependentShadowTechnique::ViewData * osgShadow::ViewDependentShadowTechnique::getViewDependentData | ( | osgUtil::CullVisitor * | cv | ) |

protected virtual

Return view dependent data for the cull visitor

## init()

virtual void osgShadow::ViewDependentShadowTechnique::init | ( |  | ) |

virtual

Initialize the ShadowedScene and some data structures.

Reimplemented from osgShadow::ShadowTechnique.

## META_Object()

osgShadow::ViewDependentShadowTechnique::META_Object | ( | osgShadow | ,
|  | ViewDependentShadowTechnique | )

Declaration of standard OSG object methods

References ViewDependentShadowTechnique().

## releaseGLObjects()

virtual void osgShadow::ViewDependentShadowTechnique::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Implements osgShadow::ShadowTechnique.

Reimplemented in osgShadow::DebugShadowMap, and osgShadow::StandardShadowMap.

## resizeGLObjectBuffers()

virtual void osgShadow::ViewDependentShadowTechnique::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Implements osgShadow::ShadowTechnique.

Reimplemented in osgShadow::DebugShadowMap, and osgShadow::StandardShadowMap.

## setViewDependentData()

virtual void osgShadow::ViewDependentShadowTechnique::setViewDependentData | ( | osgUtil::CullVisitor * | cv,
|  | ViewDependentShadowTechnique::ViewData * | data )

protected virtual

Define view dependent data for the cull visitor

References ViewDependentShadowTechnique().

## traverse()

virtual void osgShadow::ViewDependentShadowTechnique::traverse | ( | osg::NodeVisitor & | nv | ) |

virtual

Traverse shadow scene graph.

Reimplemented from osgShadow::ShadowTechnique.

## update()

virtual void osgShadow::ViewDependentShadowTechnique::update | ( | osg::NodeVisitor & | nv | ) |

virtual

Run the update traversal of the ShadowedScene and update any local cached data structures.

Reimplemented from osgShadow::ShadowTechnique.

## Member Data Documentation

## _viewDataMap

ViewDataMap osgShadow::ViewDependentShadowTechnique::_viewDataMap

protected

## _viewDataMapMutex

OpenThreads::Mutex osgShadow::ViewDependentShadowTechnique::_viewDataMapMutex

protected

Mutex used to serialize accesses to ViewDataMap

The documentation for this class was generated from the following file:

- ViewDependentShadowTechnique